//*************************************************************
//				 Java application
//					  uClipboardTestv
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOU^T
//@@@@@@@@@@ŏIXVFQOOU^U      [TN078/J68]
//*************************************************************
import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class ClipboardTest extends JFrame {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	public static void main(String[] args) {
		ClipboardTest frame=new ClipboardTest();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setVisible(true);
	}
	//
	JTextArea area;
	JTextComponent textComponent;
	//
	JButton cut=new JButton("cut");
	JButton copy=new JButton("copy");
	JButton paste=new JButton("paste");
	JButton selectall=new JButton("select all");
	//RXgN^
	public ClipboardTest(){
		//
		setTitle("ClipboardTest");
		setSize(300,300);
		//
		area=new JTextArea();
		area.setLineWrap(true);
		area.setTabSize(4);
		textComponent=(JTextComponent)(area);
		JScrollPane scPanel=new JScrollPane(area);
		//
		JPanel panel=new JPanel();
		panel.setBackground(Color.GRAY);
		panel.add(cut);
		panel.add(copy);
		panel.add(paste);
		panel.add(selectall);
		//Reig
		Container cp=getContentPane();
		cp.add(scPanel,BorderLayout.CENTER);
		cp.add(panel,BorderLayout.SOUTH);
		//Cxg
		ButtonAction btn=new ButtonAction();
		cut.addActionListener(btn);
		copy.addActionListener(btn);
		paste.addActionListener(btn);
		selectall.addActionListener(btn);
		//
		MouseAction mus=new MouseAction();
		area.addMouseListener(mus);
		//
		KeyboardAction ky=new KeyboardAction();
		area.addKeyListener(ky);
		//ŏɃ{^̗LEݒ
		enableButtons();
	}
	//{^CxgiNXj
	class ButtonAction implements ActionListener {
		public void actionPerformed(ActionEvent event){
			Object object=event.getSource();
			if(object==cut){
				textComponent.cut();
			}else if(object==copy){
				textComponent.copy();
			}else if(object==paste){
				textComponent.paste();
			}else if(object==selectall){
				textComponent.selectAll();
			}
			//
			enableButtons();
			//tH[JXJTextAreaɖ߂iȂƈꕔ̕ύXAmFłȂj
			area.requestFocus();
		}
	}
	//}EXCxgiNXj
	class MouseAction extends MouseAdapter {
		//}EX{^ꂽ
		public void mouseReleased(MouseEvent event){
			if((event.getModifiers() & MouseEvent.BUTTON1_MASK)!=0){
				//
				enableButtons();
			}
		}
	}
	//L[CxgiNXj
	class KeyboardAction extends KeyAdapter{
		//V[gJbgL[ւ̑Ή͏ɂĂ炵
		//ł̓L[Jɍ킹ă{^̗LEݒ肷
		//Shift+ɂIɂΉiނSẴL[ɑ΂ĂׂHj
		public void keyReleased(KeyEvent event){
			switch(event.getKeyCode()){
			case KeyEvent.VK_DOWN:	//L[
			case KeyEvent.VK_UP:
			case KeyEvent.VK_RIGHT:
			case KeyEvent.VK_LEFT:
			case KeyEvent.VK_X:	//cut
			case KeyEvent.VK_C:	//copy
			case KeyEvent.VK_V:	//paste
			case KeyEvent.VK_A:	//select all
				//
				enableButtons();
				break;
			}
		}
	}
	//{^̗LE
	private void enableButtons(){
		//cut copy
		String selected=textComponent.getSelectedText();
		boolean flag=((selected!=null && selected.length()>0));
		cut.setEnabled(flag);
		copy.setEnabled(flag);
		//paste
		Clipboard cb=Toolkit.getDefaultToolkit().getSystemClipboard();
		Transferable t=cb.getContents(this);
		paste.setEnabled(t.isDataFlavorSupported(DataFlavor.stringFlavor));
	}
}
